require 'sneakers'

module RenoteDac

  class ServiceQueueWorker
    include Sneakers::Worker
    # This worker will connect to "[named.queue]" queue
    # env is set to nil since by default the actual queue name would be
    # "named.queue_development"
    from_queue "#{RenoteDac.configuration.rabbitmq_queue}", env: nil

    # work method receives message payload in raw format
    # in our case it is JSON encoded string
    # which we can pass to RecentPosts service without
    # changes
    def work(message)
      # invoke service object to save message to database
      message = JSON.parse(message)
      RenoteDac::Mailer.enqueue(
        message['postmark_data']['template'],
        message['postmark_data']['address'],
        message['postmark_data']['params'],
        message['postmark_data']['attachments']
      )
      # let queue know message was received
      ack!
    end
  end
end
