module RenoteDac
  module Generators
    class InstallGenerator < Rails::Generators::Base
      # RenoteDac::Generators::InstallGenerator.source_root("lib/generators/renote_dac/templates")
      source_root File.expand_path("../templates", __FILE__)

      desc "This generator creates a renote_dac.rb initializer file at config/initializers"
      def create_initializer_file
        template "initializer.rb", "config/initializers/renote_dac.rb"
      end

      desc "This generator creates a clock.rb file at /config"
      def create_clock_file
        template "clock.rb", "config/clock.rb"
      end

      desc "This generator creates a routes.rb file at /config"
      def create_routes_file
        template "routes.rb", "config/routes.rb"
      end

      desc "This generator creates a Gemfile at rails root"
      def create_gemfile_file
        FileUtils.remove_file(Rails.root.join('Gemfile').to_s)
        template "gemfile.rb", "Gemfile"
      end

      def create_database_yml
        database_name = Rails.application.class.parent_name.underscore.gsub("_","-")
        create_file('config/database.yml',
          %{default: &default
  adapter: 'postgresql'
  encoding: unicode
  pool: <%= ENV['RAILS_MAX_THREADS'] || 5 %>
  prepared_statements: false

development:
  <<: *default
  database: #{database_name}_dev

production:
  <<: *default
          }
        )
      end
    end
  end
end