desc 'Sneakers tasks'
namespace :renote_dac do
  task :deploy do
    puts "Removing old .gem files"
    FileUtils.rm_rf(Dir["#{RenoteDac::Engine.root}/*.gem"])

    puts "Incrementing Minor Patch Version"
    file = File.read(RenoteDac::Engine.root.join('lib','renote_dac','version.rb'))
    version = file.match(/\d+\.\d+\.\d+/).to_s
    new_version = "#{version.split(".")[(0..1)].join(".")}.#{version.split(".").last.to_i + 1}"
    FileUtils.rm_rf(Dir["#{RenoteDac::Engine.root}/lib/renote_dac/version.rb"])
    File.open(RenoteDac::Engine.root.join('lib', 'renote_dac', 'version.rb'), 'w') {|f| f.write("#{file.gsub(version, "#{new_version}")}") }

    system "gem build renote_dac.gemspec"

    system "bin/deploy 'rake app:renote_dac automatic deployment - #{version} to version #{new_version}'"
  end
end

require 'sneakers/tasks'